#ifndef OCR_H
#define OCR_H

#define _GNU_SOURCE

#include <pam.h>
#include <stdint.h>
#include <inttypes.h>
#include <assert.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/wait.h>

typedef uint32_t Pixcol;
#define PSPIXCOL(priscan) priscan##32

typedef struct {
  const char *s; /* valid until next call to ocr() */
  int l,r; /* column numbers */
  int ctx; /* match context index */
} OcrResultGlyph;

typedef const struct OcrGlyphContextDeveloperInfo *OcrCellContext;
extern const struct OcrGlyphContextDeveloperInfo *ocr_celltype_text;
extern const struct OcrGlyphContextDeveloperInfo *ocr_celltype_number;

typedef struct OcrReader OcrReader;
OcrReader *ocr_init(int h);

OcrResultGlyph *ocr(OcrReader *rd, int w, Pixcol cols[]);
  /* return value is array terminated by {0,-1,-1}
   * array is valid until next call to ocr()
   */

void debug_flush(void);

#define eassert assert
#define debug stdout

const char *get_vardir(void);

#endif /*OCR_H*/
